// RegPluginLibrary("warmth");

enum WarmthEvent
{
	Handle:Warmth_OnSpawn = 0,		// public Action:CallBack(client, const Float:center[3], &HpPerSec, &LifeSec, rgb[3]); - теплота вот-вот будет создана (если LifeSec < 1, не будет удалена) (если в rgb все нули, то цвет рандомный каждую секунду)
	Handle:Warmth_OnSpawnPost,		// public CallBack(WarmthID); - создана
	Handle:Warmth_OnRemovedPost,	// public CallBack(WarmthID); - удалена (истекло время или владелец создал новую теплоту)
	Handle:Warmth_OnRegenStart,		// public Action:CallBack(client, WarmthID); - игрок вот-вот начнёт восстанавливать здоровье (вызывается 1 раз после входа в теплоту)
	Handle:Warmth_OnRegenStartPost,	// public CallBack(client, WarmthID); - начал восстанавливать здоровье (вызывается 1 раз после входа в теплоту)
	Handle:Warmth_OnRegenPost,		// public CallBack(client, WarmthID); - вызывается каждую секунду
	Handle:Warmth_OnRegenEndPost	// public CallBack(client, WarmthID); - восстановление здоровья прекращено (восстановил, мёртв, вышел, теплота удалена)
};
		
native WARMTH_HookEvent(WarmthEvent:event, Function:CallBack);

native WARMTH_Count(client = 0);						// кол-во активной теплоты (если client != 0, то будет искать лишь его теплоту)
native WARMTH_IDList(&Handle:hAr);						// список WarmthID активной теплоты (Handle закройте)
native WARMTH_Owner(WarmthID);							// индекс того, кто создал теплоту, или 0
native bool:WARMTH_SetColor(WarmthID, r, g, b);			// чтобы каждую секунду был случайный цвет, укажите 0 0 0
native bool:WARMTH_Center(WarmthID, Float:center[3]);	// координаты центра
native bool:WARMTH_Remove(WarmthID);					// удалить теплоту
native bool:WARMTH_RegenOn(client);						// true, если в текущий момент игрок восстанавливает здоровье

native WARMTH_HpPerSec(WarmthID);						// HP в секунду восстанавливаемые теплотой (отрицательное значение снимает HP у игроков) (вернёт 0, если ошибка)
native bool:WARMTH_SetHpPerSec(WarmthID, HpPerSec);		// HpPerSec не должно быть 0

native bool:WARMTH_SecLeft(WarmthID, &SecLeft);			// через сколько секунд теплота будет удалена (0 = не будет удалена)
native bool:WARMTH_SetSecLeft(WarmthID, SecLeft);		// 

// Выдать/изменить теплоту любому не-бот игроку (лучше использовать после VIP_EVENT_AUTHORIZED).
// Если CountPerRound < 1, то это отберёт доступ и HpPerSec/LifeSec неважны.
// Данные права будут активны пока игрок не покинет сервер.
//
// CountPerRound	- кол-во использований за раунд (перезаход на сервер не обнуляет счетчик)
// HpPerSec			- hp в сек регенерируемые теплотой
// LifeSec			- через сколько сек удалить теплоту (0 = не удалять)
native bool:WARMTH_SetAccess(client, CountPerRound, HpPerSec, LifeSec);
native WARMTH_GetAccess(client, &CountPerRound, &HpPerSec, &LifeSec);

// Изменить параметры счетчика (сколько теплоты игрок создал за раунд), что позволит ему создать ещё, или наоборот запретит.
// Счетчик обнуляется только в round_start.
native bool:WARMTH_SetCountPerRound(client, CountPerRound);
native WARMTH_GetCountPerRound(client);

public SharedPlugin:__pl_warmth = 
{
	name = "warmth",
	file = "ws_vip/warmth.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_warmth_SetNTVOptional()
{
	MarkNativeAsOptional("WARMTH_HookEvent");
	MarkNativeAsOptional("WARMTH_Count");
	MarkNativeAsOptional("WARMTH_IDList");
	MarkNativeAsOptional("WARMTH_Owner");
	MarkNativeAsOptional("WARMTH_SetColor");
	MarkNativeAsOptional("WARMTH_Center");
	MarkNativeAsOptional("WARMTH_Remove");
	MarkNativeAsOptional("WARMTH_RegenOn");
	MarkNativeAsOptional("WARMTH_HpPerSec");
	MarkNativeAsOptional("WARMTH_SetHpPerSec");
	MarkNativeAsOptional("WARMTH_SecLeft");
	MarkNativeAsOptional("WARMTH_SetSecLeft");
	MarkNativeAsOptional("WARMTH_SetAccess");
	MarkNativeAsOptional("WARMTH_GetAccess");
	MarkNativeAsOptional("WARMTH_SetCountPerRound");
	MarkNativeAsOptional("WARMTH_GetCountPerRound");
}
#endif